{
    "$graph": [
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "run_BUSCO.py"
            ],
            "inputs": [
                {
                    "id": "#BUSCO-v3.cwl/blastSingleCore",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--blast_single_core"
                    },
                    "label": "Force tblastn to run on a single core",
                    "doc": "Force tblastn to run on a single core and ignore the --cpu argument for\nthis step only. Useful if inconsistencies when using multiple threads are\nnoticed\n"
                },
                {
                    "id": "#BUSCO-v3.cwl/cpu",
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--cpu"
                    },
                    "label": "Specify the number of threads/cores to use (default: 1)"
                },
                {
                    "id": "#BUSCO-v3.cwl/evalue",
                    "type": [
                        "null",
                        "float"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--evalue"
                    },
                    "label": "E-value cutoff for BLAST searches",
                    "doc": "Allowed formats: 0.001 or 1e-03 (default: 1e-03).\n"
                },
                {
                    "id": "#BUSCO-v3.cwl/force",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--force"
                    },
                    "label": "Force rewriting of existing files/folders",
                    "doc": "Must be used when output files with the provided name already exist.\n"
                },
                {
                    "id": "#BUSCO-v3.cwl/help",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--help"
                    },
                    "label": "Show this help message and exit"
                },
                {
                    "id": "#BUSCO-v3.cwl/lineage",
                    "type": "Directory",
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--lineage_path"
                    },
                    "label": "Location of the BUSCO lineage data to use (e.g. fungi_odb9)",
                    "doc": "Specify location of the BUSCO lineage data to be used.\nVisit http://busco.ezlab.org/ for available lineages.\n"
                },
                {
                    "id": "#BUSCO-v3.cwl/long",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--long"
                    },
                    "label": "Turn on Augustus optimization mode for self-training (default: Off)",
                    "doc": "Adds substantially to the run time!\nCan improve results for some non-model organisms.\n"
                },
                {
                    "id": "#BUSCO-v3.cwl/mode",
                    "type": "#BUSCO-assessment_modes.yaml/assessment_modes",
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--mode"
                    },
                    "label": "Sets the assessment MODE: genome, proteins, transcriptome",
                    "doc": "Specify which BUSCO analysis mode to run.\nThere are three valid modes:\n- geno or genome, for genome assemblies (DNA).\n- tran or transcriptome, for transcriptome assemblies (DNA).\n- prot or proteins, for annotated gene sets (protein).\n"
                },
                {
                    "id": "#BUSCO-v3.cwl/outputName",
                    "type": "string",
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--out"
                    },
                    "label": "Name to use for the run and all temporary files (appended)",
                    "doc": "Give your analysis run a recognisable short name.\nOutput folders and files will be labelled (prepended) with this name.\nWARNING: do not provide a path.\n"
                },
                {
                    "id": "#BUSCO-v3.cwl/quiet",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--quiet"
                    },
                    "label": "Disable the info logs, display only errors"
                },
                {
                    "id": "#BUSCO-v3.cwl/regionLimit",
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--limit"
                    },
                    "label": "How many candidate regions to consider (integer, default: 3)",
                    "doc": "NB: this limit is on scaffolds, chromosomes, or transcripts, not individual hit regions.\n"
                },
                {
                    "id": "#BUSCO-v3.cwl/restart",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--restart"
                    },
                    "label": "Restart the BUSCO run from the last successfully-completed step",
                    "doc": "NB: If all the required results files from previous steps are not all found then this will not be possible.\n"
                },
                {
                    "format": "http://edamontology.org/format_1929",
                    "id": "#BUSCO-v3.cwl/sequenceFile",
                    "type": "File",
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--in"
                    },
                    "label": "Sequence file in FASTA format",
                    "doc": "Input sequence file in FASTA format (not compressed/zipped!).\nCan be an assembled genome (genome mode) or transcriptome (DNA,\ntranscriptome mode), or protein sequences from an annotated gene set\n(proteins mode).\nNB: select just one transcript/protein per gene for your input,\notherwise they will appear as 'Duplicated' matches.\n"
                },
                {
                    "id": "#BUSCO-v3.cwl/species",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--species"
                    },
                    "label": "Name of existing Augustus species gene finding parameters",
                    "doc": "See Augustus documentation for available options.\nEach lineage has a default species (see below on assessment sets).\nSelecting a closely-related species usually produces better results.\n"
                },
                {
                    "id": "#BUSCO-v3.cwl/tarzip",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--tarzip"
                    },
                    "label": "Results folders with many files will be tarzipped"
                },
                {
                    "id": "#BUSCO-v3.cwl/tempPath",
                    "type": [
                        "null",
                        "Directory"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--tmp"
                    },
                    "label": "Where to store temporary files (default: ./tmp)"
                },
                {
                    "id": "#BUSCO-v3.cwl/version",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--version"
                    },
                    "label": "Show this version information and exit"
                }
            ],
            "doc": "BUSCO v3 provides quantitative measures for the assessment of genome assembly, gene set, and transcriptome completeness, based on evolutionarily-informed expectations of gene content from near-universal single-copy orthologs selected from OrthoDB v9. BUSCO assessments are implemented in open-source software, with a large selection of lineage-specific sets of Benchmarking Universal Single-Copy Orthologs. These conserved orthologs are ideal candidates for large-scale phylogenomics studies, and the annotated BUSCO gene models built during genome assessments provide a comprehensive gene predictor training set for use as part of genome annotation pipelines.\nPlease visit http://busco.ezlab.org/ for full documentation.\nThe BUSCO assessment software distribution is available from the public GitLab project: https://gitlab.com/ezlab/busco where it can be downloaded or cloned using a git client (git clone https://gitlab.com/ezlab/busco.git). We encourage users to opt for the git client option in order to facilitate future updates.\nBUSCO is written for Python 3.x and Python 2.7+. It runs with the standard packages. We recommend using Python3 when available.\n",
            "label": "Assesses genome assembly and annotation completeness with single-copy orthologs",
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "coresMin": 1
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "type": "enum",
                            "name": "#BUSCO-assessment_modes.yaml/assessment_modes",
                            "symbols": [
                                "#BUSCO-assessment_modes.yaml/assessment_modes/geno",
                                "#BUSCO-assessment_modes.yaml/assessment_modes/prot",
                                "#BUSCO-assessment_modes.yaml/assessment_modes/tran"
                            ]
                        }
                    ]
                }
            ],
            "hints": [
                {
                    "class": "SoftwareRequirement",
                    "packages": [
                        {
                            "specs": [
                                "https://identifiers.org/rrid/RRID:SCR_015008"
                            ],
                            "version": [
                                "3.0.2"
                            ],
                            "package": "BUSCO"
                        }
                    ]
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "comics/busco:3.0.2"
                },
                {
                    "class": "http://galaxyproject.org/cwl#interface",
                    "http://galaxyproject.org/cwl#inputs": [
                        {
                            "http://galaxyproject.org/cwl#name": "blastSingleCore",
                            "http://galaxyproject.org/cwl#type": "boolean",
                            "http://galaxyproject.org/cwl#optional": true
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "cpu",
                            "http://galaxyproject.org/cwl#type": "integer",
                            "http://galaxyproject.org/cwl#optional": true
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "evalue",
                            "http://galaxyproject.org/cwl#type": "float",
                            "http://galaxyproject.org/cwl#optional": true
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "force",
                            "http://galaxyproject.org/cwl#type": "boolean",
                            "http://galaxyproject.org/cwl#optional": true
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "help",
                            "http://galaxyproject.org/cwl#type": "boolean",
                            "http://galaxyproject.org/cwl#optional": true
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "lineage",
                            "http://galaxyproject.org/cwl#type": "data"
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "long",
                            "http://galaxyproject.org/cwl#type": "boolean",
                            "http://galaxyproject.org/cwl#optional": true
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "mode",
                            "http://galaxyproject.org/cwl#value": "tran",
                            "http://galaxyproject.org/cwl#type": "text"
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "outputName",
                            "http://galaxyproject.org/cwl#value": "TEST",
                            "http://galaxyproject.org/cwl#type": "text"
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "quiet",
                            "http://galaxyproject.org/cwl#type": "boolean",
                            "http://galaxyproject.org/cwl#optional": true
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "regionLimit",
                            "http://galaxyproject.org/cwl#type": "integer",
                            "http://galaxyproject.org/cwl#optional": true
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "restart",
                            "http://galaxyproject.org/cwl#type": "boolean",
                            "http://galaxyproject.org/cwl#optional": true
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "sequenceFile",
                            "http://galaxyproject.org/cwl#format": "txt",
                            "http://galaxyproject.org/cwl#type": "data"
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "species",
                            "http://galaxyproject.org/cwl#type": "text",
                            "http://galaxyproject.org/cwl#optional": true
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "tarzip",
                            "http://galaxyproject.org/cwl#type": "boolean",
                            "http://galaxyproject.org/cwl#optional": true
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "tempPath",
                            "http://galaxyproject.org/cwl#type": "data",
                            "http://galaxyproject.org/cwl#optional": true
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "version",
                            "http://galaxyproject.org/cwl#type": "boolean",
                            "http://galaxyproject.org/cwl#optional": true
                        }
                    ]
                }
            ],
            "id": "#BUSCO-v3.cwl",
            "http://schema.org/copyrightHolder": "EMBL - European Bioinformatics Institute, 2018",
            "http://schema.org/license": "https://www.apache.org/licenses/LICENSE-2.0",
            "http://schema.org/author": "Maxim Scheremetjew",
            "outputs": [
                {
                    "id": "#BUSCO-v3.cwl/blastOutput",
                    "doc": "tBLASTn results, not created for assessment of proteins.\nFile: tblastn_XXXX.txt = tabular tBLASTn results\nFile: coordinates_XXXX.txt = locations of BUSCO matches (genome mode)\n",
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "run_$(inputs.outputName)/blast_output"
                    }
                },
                {
                    "id": "#BUSCO-v3.cwl/fullTable",
                    "doc": "Contains the complete results in a tabular format with scores and lengths of BUSCO matches, and coordinates (for genome mode) or gene/protein IDs (for transcriptome or proteins mode).\n",
                    "type": "File",
                    "outputBinding": {
                        "glob": "run_$(inputs.outputName)/full_table_*.tsv"
                    },
                    "format": "https://www.iana.org/assignments/media-types/text/tab-separated-values"
                },
                {
                    "id": "#BUSCO-v3.cwl/hmmerOutput",
                    "label": "Tabular format HMMER output of searches with BUSCO HMMs",
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "run_$(inputs.outputName)/hmmer_output"
                    }
                },
                {
                    "id": "#BUSCO-v3.cwl/missingBUSCOs",
                    "label": "Contains a list of missing BUSCOs",
                    "type": "File",
                    "outputBinding": {
                        "glob": "run_$(inputs.outputName)/missing_busco_list_*.tsv"
                    },
                    "format": "https://www.iana.org/assignments/media-types/text/tab-separated-values"
                },
                {
                    "id": "#BUSCO-v3.cwl/shortSummary",
                    "doc": "Contains a plain text summary of the results in BUSCO notation.\nAlso gives a brief breakdown of the metrics.\n",
                    "type": "File",
                    "outputBinding": {
                        "glob": "run_$(inputs.outputName)/short_summary_*.txt"
                    }
                },
                {
                    "id": "#BUSCO-v3.cwl/translatedProteins",
                    "label": "Transcript sequence translations, only created during transcriptome assessment",
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "run_$(inputs.outputName)/translated_proteins"
                    }
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "diamond",
                "blastx"
            ],
            "inputs": [
                {
                    "id": "#Diamon.blastx-v0.9.21.cwl/blockSize",
                    "type": [
                        "null",
                        "float"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--block-size"
                    },
                    "label": "sequence block size in billions of letters (default=2.0)"
                },
                {
                    "id": "#Diamon.blastx-v0.9.21.cwl/databaseFile",
                    "type": "File",
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--db"
                    },
                    "label": "DIAMOND database input file",
                    "doc": "Path to the DIAMOND database file."
                },
                {
                    "id": "#Diamon.blastx-v0.9.21.cwl/outputFormat",
                    "type": [
                        "null",
                        "#Diamond-output_formats.yaml/output_formats"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--outfmt"
                    },
                    "label": "Format of the output file",
                    "doc": "0   = BLAST pairwise\n5   = BLAST XML\n6   = BLAST tabular\n100 = DIAMOND alignment archive (DAA)\n101 = SAM\n\nValue 6 may be followed by a space-separated list of these keywords"
                },
                {
                    "id": "#Diamon.blastx-v0.9.21.cwl/queryGeneticCode",
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--min-orf"
                    },
                    "label": "Genetic code used for the translation of the query sequences",
                    "doc": "Ignore translated sequences that do not contain an open reading frame of at least this length.\nBy default this feature is disabled for sequences of length below 30, set to 20 for sequences of length below 100, and set to 40 otherwise. Setting this option to 1 will disable this feature.\n"
                },
                {
                    "format": "http://edamontology.org/format_1929",
                    "id": "#Diamon.blastx-v0.9.21.cwl/queryInputFile",
                    "type": "File",
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--query"
                    },
                    "label": "Query input file in FASTA",
                    "doc": "Path to the query input file in FASTA or FASTQ format (may be gzip compressed). If this parameter is omitted, the input will be read from stdin\n"
                },
                {
                    "id": "#Diamon.blastx-v0.9.21.cwl/strand",
                    "type": [
                        "null",
                        "#Diamond-strand_values.yaml/strand"
                    ],
                    "inputBinding": {
                        "position": -3,
                        "prefix": "--strand"
                    },
                    "label": "Set strand of query to align for translated searches",
                    "doc": "Set strand of query to align for translated searches. By default both strands are searched. Valid values are {both, plus, minus}"
                },
                {
                    "id": "#Diamon.blastx-v0.9.21.cwl/taxonList",
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "int"
                        }
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--taxonlist"
                    },
                    "label": "Protein accession to taxon identifier NCBI mapping file",
                    "doc": "Comma-separated list of NCBI taxonomic IDs to filter the database by. Any taxonomic rank can be used, and only reference sequences matching one of the specified taxon ids will be searched against. Using this option requires setting the --taxonmap and --taxonnodes parameters for makedb.\n"
                },
                {
                    "id": "#Diamon.blastx-v0.9.21.cwl/threads",
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--threads"
                    },
                    "label": "Number of CPU threads",
                    "doc": "Number of CPU threads. By default, the program will auto-detect and use all available virtual cores on the machine.\n"
                }
            ],
            "outputs": [
                {
                    "id": "#Diamon.blastx-v0.9.21.cwl/matches",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.queryInputFile.basename).diamond_matches"
                    },
                    "format": "http://edamontology.org/format_2333"
                }
            ],
            "doc": "DIAMOND is a sequence aligner for protein and translated DNA searches,\ndesigned for high performance analysis of big sequence data.\n\nThe key features are:\n      + Pairwise alignment of proteins and translated DNA at 500x-20,000x speed of BLAST.\n      + Frameshift alignments for long read analysis.\n      + Low resource requirements and suitable for running on standard desktops or laptops.\n      + Various output formats, including BLAST pairwise, tabular and XML, as well as taxonomic classification.\n\nPlease visit https://github.com/bbuchfink/diamond for full documentation.\n\nReleases can be downloaded from https://github.com/bbuchfink/diamond/releases\n",
            "label": "Aligns DNA query sequences against a protein reference database",
            "arguments": [
                {
                    "position": 0,
                    "prefix": "--out",
                    "valueFrom": "$(inputs.queryInputFile.basename).diamond_matches"
                }
            ],
            "requirements": [
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "type": "enum",
                            "name": "#Diamond-strand_values.yaml/strand",
                            "symbols": [
                                "#Diamond-strand_values.yaml/strand/both",
                                "#Diamond-strand_values.yaml/strand/plus",
                                "#Diamond-strand_values.yaml/strand/minus"
                            ]
                        },
                        {
                            "type": "enum",
                            "name": "#Diamond-output_formats.yaml/output_formats",
                            "symbols": [
                                "#Diamond-output_formats.yaml/output_formats/0",
                                "#Diamond-output_formats.yaml/output_formats/5",
                                "#Diamond-output_formats.yaml/output_formats/6",
                                "#Diamond-output_formats.yaml/output_formats/100",
                                "#Diamond-output_formats.yaml/output_formats/101",
                                "#Diamond-output_formats.yaml/output_formats/102"
                            ]
                        }
                    ]
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 1000
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "buchfink/diamond:version0.9.21"
                }
            ],
            "id": "#Diamon.blastx-v0.9.21.cwl",
            "http://schema.org/author": "Maxim Scheremetjews",
            "http://schema.org/copyrightHolder": "EMBL - European Bioinformatics Institute, 2018",
            "http://schema.org/license": "https://www.apache.org/licenses/LICENSE-2.0"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "phmmer"
            ],
            "inputs": [
                {
                    "id": "#phmmer-v3.2.cwl/bitscoreThreshold",
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "-T"
                    },
                    "label": "report sequences >= this bit score threshold in output"
                },
                {
                    "id": "#phmmer-v3.2.cwl/cpu",
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--cpu"
                    },
                    "label": "Number of parallel CPU workers to use for multithreads"
                },
                {
                    "id": "#phmmer-v3.2.cwl/seqFile",
                    "type": "File",
                    "format": "http://edamontology.org/format_1929",
                    "inputBinding": {
                        "position": 1
                    },
                    "label": "Query sequence(s) file",
                    "doc": "Search one or more query protein sequences against a protein sequence database.\n"
                },
                {
                    "id": "#phmmer-v3.2.cwl/seqdb",
                    "type": "File",
                    "format": "http://edamontology.org/format_1929",
                    "inputBinding": {
                        "position": 2
                    },
                    "label": "Target database of sequences"
                }
            ],
            "outputs": [
                {
                    "id": "#phmmer-v3.2.cwl/matches",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.seqFile.basename).phmmer_matches.tblout"
                    }
                },
                {
                    "id": "#phmmer-v3.2.cwl/programOutput",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.seqFile.basename).phmmer_matches.out"
                    }
                }
            ],
            "doc": "The phmmer and jackhmmer programs search a single protein sequence against a protein sequence database, akin to BLASTP and PSIBLAST, respectively. (Internally, they just produce a profile HMM from the query sequence, then run HMM searches.) Please visit https://github.com/EddyRivasLab/hmmer for full documentation.\nReleases can be downloaded from https://github.com/EddyRivasLab/hmmer/releases\n",
            "label": "Search a single protein sequence against a protein sequence database. (BLASTP-like)",
            "arguments": [
                {
                    "position": 0,
                    "prefix": "--tblout",
                    "valueFrom": "$(inputs.seqFile.basename).phmmer_matches.tblout"
                },
                {
                    "position": 0,
                    "prefix": "-o",
                    "valueFrom": "$(inputs.seqFile.basename).phmmer_matches.out"
                }
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 1024,
                    "coresMin": 2,
                    "coresMax": 4
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/hmmer:3.2--hfc679d8_3"
                },
                {
                    "class": "http://galaxyproject.org/cwl#interface",
                    "http://galaxyproject.org/cwl#inputs": [
                        {
                            "http://galaxyproject.org/cwl#name": "bitscoreThreshold",
                            "http://galaxyproject.org/cwl#type": "integer",
                            "http://galaxyproject.org/cwl#optional": true
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "cpu",
                            "http://galaxyproject.org/cwl#type": "integer",
                            "http://galaxyproject.org/cwl#optional": true
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "seqFile",
                            "http://galaxyproject.org/cwl#type": "data",
                            "http://galaxyproject.org/cwl#format": "txt"
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "seqdb",
                            "http://galaxyproject.org/cwl#type": "data",
                            "http://galaxyproject.org/cwl#format": "txt"
                        }
                    ]
                }
            ],
            "id": "#phmmer-v3.2.cwl",
            "http://schema.org/copyrightHolder": "EMBL - European Bioinformatics Institute, 2018",
            "http://schema.org/license": "https://www.apache.org/licenses/LICENSE-2.0",
            "http://schema.org/author": "Maxim Scheremetjew"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "cmsearch"
            ],
            "inputs": [
                {
                    "id": "#infernal-cmsearch-v1.1.2.cwl/covariance_model_database",
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    }
                },
                {
                    "id": "#infernal-cmsearch-v1.1.2.cwl/cpu",
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--cpu"
                    },
                    "label": "Number of parallel CPU workers to use for multithreads"
                },
                {
                    "default": false,
                    "id": "#infernal-cmsearch-v1.1.2.cwl/cut_ga",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--cut_ga"
                    },
                    "label": "use CM's GA gathering cutoffs as reporting thresholds"
                },
                {
                    "id": "#infernal-cmsearch-v1.1.2.cwl/omit_alignment_section",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--noali"
                    },
                    "label": "Omit the alignment section from the main output.",
                    "doc": "This can greatly reduce the output volume."
                },
                {
                    "default": false,
                    "id": "#infernal-cmsearch-v1.1.2.cwl/only_hmm",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--hmmonly"
                    },
                    "label": "Only use the filter profile HMM for searches, do not use the CM",
                    "doc": "Only filter stages F1 through F3 will be executed, using strict P-value\nthresholds (0.02 for F1, 0.001 for F2 and 0.00001 for F3). Additionally\na bias composition filter is used after the F1 stage (with P=0.02\nsurvival threshold). Any hit that survives all stages and has an HMM\nE-value or bit score above the reporting threshold will be output.\n"
                },
                {
                    "format": "http://edamontology.org/format_1929",
                    "id": "#infernal-cmsearch-v1.1.2.cwl/query_sequences",
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "streamable": true
                },
                {
                    "id": "#infernal-cmsearch-v1.1.2.cwl/search_space_size",
                    "type": "int",
                    "inputBinding": {
                        "position": 0,
                        "prefix": "-Z"
                    },
                    "label": "search space size in *Mb* to <x> for E-value calculations"
                }
            ],
            "outputs": [
                {
                    "id": "#infernal-cmsearch-v1.1.2.cwl/matches",
                    "doc": "http://eddylab.org/infernal/Userguide.pdf#page=60",
                    "label": "target hits table, format 2",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.query_sequences.basename).cmsearch_matches.tbl"
                    }
                },
                {
                    "id": "#infernal-cmsearch-v1.1.2.cwl/programOutput",
                    "label": "direct output to file, not stdout",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.query_sequences.basename).cmsearch.out"
                    }
                }
            ],
            "doc": "Infernal (\"INFERence of RNA ALignment\") is for searching DNA sequence databases for RNA structure and sequence similarities. It is an implementation of a special case of profile stochastic context-free grammars called covariance models (CMs). A CM is like a sequence profile, but it scores a combination of sequence consensus and RNA secondary structure consensus, so in many cases, it is more capable of identifying RNA homologs that conserve their secondary structure more than their primary sequence.\nPlease visit http://eddylab.org/infernal/ for full documentation.\nVersion 1.1.2 can be downloaded from http://eddylab.org/infernal/infernal-1.1.2.tar.gz\n",
            "label": "Search sequence(s) against a covariance model database",
            "arguments": [
                {
                    "position": 0,
                    "prefix": "--tblout",
                    "valueFrom": "$(inputs.query_sequences.basename).cmsearch_matches.tbl"
                },
                {
                    "position": 0,
                    "prefix": "-o",
                    "valueFrom": "$(inputs.query_sequences.basename).cmsearch.out"
                }
            ],
            "hints": [
                {
                    "class": "SoftwareRequirement",
                    "packages": [
                        {
                            "specs": [
                                "https://identifiers.org/rrid/RRID:SCR_011809"
                            ],
                            "version": [
                                "1.1.2"
                            ],
                            "package": "infernal"
                        }
                    ]
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/infernal:1.1.2--h470a237_1"
                },
                {
                    "class": "http://galaxyproject.org/cwl#interface",
                    "http://galaxyproject.org/cwl#inputs": [
                        {
                            "http://galaxyproject.org/cwl#name": "covariance_model_database",
                            "http://galaxyproject.org/cwl#type": "data",
                            "http://galaxyproject.org/cwl#format": "txt"
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "cpu",
                            "http://galaxyproject.org/cwl#type": "integer",
                            "http://galaxyproject.org/cwl#optional": true
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "cut_ga",
                            "http://galaxyproject.org/cwl#type": "boolean",
                            "http://galaxyproject.org/cwl#optional": true
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "omit_alignment_section",
                            "http://galaxyproject.org/cwl#type": "boolean",
                            "http://galaxyproject.org/cwl#optional": true
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "only_hmm",
                            "http://galaxyproject.org/cwl#type": "boolean",
                            "http://galaxyproject.org/cwl#optional": true
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "query_sequences",
                            "http://galaxyproject.org/cwl#type": "data",
                            "http://galaxyproject.org/cwl#format": "txt"
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "search_space_size",
                            "http://galaxyproject.org/cwl#type": "integer",
                            "http://galaxyproject.org/cwl#default_value": 1000,
                            "http://galaxyproject.org/cwl#optional": true
                        }
                    ]
                }
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "id": "#infernal-cmsearch-v1.1.2.cwl",
            "http://schema.org/copyrightHolder": "EMBL - European Bioinformatics Institute",
            "http://schema.org/license": "https://www.apache.org/licenses/LICENSE-2.0",
            "http://schema.org/author": "Michael Crusoe, Maxim Scheremetjew"
        },
        {
            "class": "CommandLineTool",
            "id": "#InterProScan-v5.cwl",
            "baseCommand": [],
            "inputs": [
                {
                    "format": "http://edamontology.org/format_1929",
                    "id": "#InterProScan-v5.cwl/i5/inputFile",
                    "type": "File",
                    "inputBinding": {
                        "position": 8,
                        "prefix": "--input"
                    },
                    "label": "Input file path",
                    "doc": "Optional, path to fasta file that should be loaded on Master startup. Alternatively, in CONVERT mode, the InterProScan 5 XML file to convert."
                },
                {
                    "id": "#InterProScan-v5.cwl/i5/applications",
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "#InterProScan-apps.yaml/apps"
                        }
                    ],
                    "inputBinding": {
                        "position": 9,
                        "itemSeparator": ",",
                        "prefix": "--applications"
                    },
                    "label": "Analysis",
                    "doc": "Optional, comma separated list of analyses. If this option is not set, ALL analyses will be run."
                },
                {
                    "id": "#InterProScan-v5.cwl/i5/outputFormat",
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "#InterProScan-protein_formats.yaml/protein_formats"
                        }
                    ],
                    "default": "TSV",
                    "inputBinding": {
                        "position": 10,
                        "itemSeparator": ",",
                        "prefix": "--formats"
                    },
                    "label": "output format",
                    "doc": "Optional, case-insensitive, comma separated list of output formats. Supported formats are TSV, XML, JSON, GFF3, HTML and SVG. Default for protein sequences are TSV, XML and GFF3, or for nucleotide sequences GFF3 and XML."
                },
                {
                    "id": "#InterProScan-v5.cwl/i5/databases",
                    "type": "Directory"
                },
                {
                    "id": "#InterProScan-v5.cwl/i5/disableResidueAnnotation",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 11,
                        "prefix": "--disable-residue-annot"
                    },
                    "label": "Disables residue annotation",
                    "doc": "Optional, excludes sites from the XML, JSON output."
                },
                {
                    "id": "#InterProScan-v5.cwl/i5/seqtype",
                    "type": [
                        "null",
                        {
                            "type": "enum",
                            "symbols": [
                                "#InterProScan-v5.cwl/i5/seqtype/seqtype/p",
                                "#InterProScan-v5.cwl/i5/seqtype/seqtype/n"
                            ],
                            "name": "#InterProScan-v5.cwl/i5/seqtype/seqtype"
                        }
                    ],
                    "inputBinding": {
                        "position": 12,
                        "prefix": "--seqtype"
                    },
                    "label": "Sequence type",
                    "doc": "Optional, the type of the input sequences (dna/rna (n) or protein (p)). The default sequence type is protein."
                }
            ],
            "outputs": [
                {
                    "id": "#InterProScan-v5.cwl/i5/i5Annotations",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.inputFile.nameroot).fasta.tsv"
                    }
                }
            ],
            "doc": "InterProScan is the software package that allows sequences (protein and nucleic) to be scanned against InterPro's signatures. Signatures are predictive models, provided by several different databases, that make up the InterPro consortium.\n\nThis tool description is using a Docker container tagged as version v5.30-69.0.\n\nDocumentation on how to run InterProScan 5 can be found here: https://github.com/ebi-pf-team/interproscan/wiki/HowToRun",
            "label": "InterProScan: protein sequence classifier",
            "arguments": [
                {
                    "position": 0,
                    "shellQuote": false,
                    "valueFrom": "cp -r /opt/interproscan $(runtime.outdir)/interproscan;"
                },
                {
                    "position": 1,
                    "shellQuote": false,
                    "valueFrom": "cp -rs $(inputs.databases.path)/data/* $(runtime.outdir)/interproscan/data;"
                },
                {
                    "position": 2,
                    "shellQuote": false,
                    "valueFrom": "$(runtime.outdir)/interproscan/interproscan.sh"
                },
                {
                    "position": 3,
                    "valueFrom": "--disable-precalc"
                },
                {
                    "position": 4,
                    "valueFrom": "--goterms"
                },
                {
                    "position": 5,
                    "valueFrom": "--pathways"
                },
                {
                    "position": 6,
                    "prefix": "--tempdir",
                    "valueFrom": "$(runtime.tmpdir)"
                }
            ],
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "type": "enum",
                            "name": "#InterProScan-apps.yaml/apps",
                            "symbols": [
                                "#InterProScan-apps.yaml/apps/TIGRFAM",
                                "#InterProScan-apps.yaml/apps/SFLD",
                                "#InterProScan-apps.yaml/apps/SUPERFAMILY",
                                "#InterProScan-apps.yaml/apps/Gene3D",
                                "#InterProScan-apps.yaml/apps/Hamap",
                                "#InterProScan-apps.yaml/apps/Coils",
                                "#InterProScan-apps.yaml/apps/ProSiteProfiles",
                                "#InterProScan-apps.yaml/apps/SMART",
                                "#InterProScan-apps.yaml/apps/CDD",
                                "#InterProScan-apps.yaml/apps/PRINTS",
                                "#InterProScan-apps.yaml/apps/PIRSF",
                                "#InterProScan-apps.yaml/apps/ProSitePatterns",
                                "#InterProScan-apps.yaml/apps/PfamA",
                                "#InterProScan-apps.yaml/apps/ProDom",
                                "#InterProScan-apps.yaml/apps/MobiDBLite",
                                "#InterProScan-apps.yaml/apps/SignalP_GRAM_POSITIVE",
                                "#InterProScan-apps.yaml/apps/SignalP_GRAM_NEGATIVE",
                                "#InterProScan-apps.yaml/apps/SignalP_EUK",
                                "#InterProScan-apps.yaml/apps/Phobius",
                                "#InterProScan-apps.yaml/apps/TMHMM"
                            ]
                        },
                        {
                            "type": "enum",
                            "name": "#InterProScan-protein_formats.yaml/protein_formats",
                            "symbols": [
                                "#InterProScan-protein_formats.yaml/protein_formats/TSV",
                                "#InterProScan-protein_formats.yaml/protein_formats/XML",
                                "#InterProScan-protein_formats.yaml/protein_formats/GFF3",
                                "#InterProScan-protein_formats.yaml/protein_formats/JSON",
                                "#InterProScan-protein_formats.yaml/protein_formats/HTML",
                                "#InterProScan-protein_formats.yaml/protein_formats/SVG"
                            ]
                        }
                    ]
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 8192,
                    "coresMin": 3
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "biocontainers/interproscan:v5.30-69.0_cv1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "class": "http://galaxyproject.org/cwl#interface",
                    "http://galaxyproject.org/cwl#inputs": [
                        {
                            "http://galaxyproject.org/cwl#name": "applications",
                            "http://galaxyproject.org/cwl#type": "text",
                            "http://galaxyproject.org/cwl#optional": true
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "proteinFile",
                            "http://galaxyproject.org/cwl#type": "data",
                            "http://galaxyproject.org/cwl#format": "txt"
                        }
                    ]
                }
            ],
            "http://schema.org/author": "Michael Crusoe, Aleksandra Ola Tarkowska, Maxim Scheremetjew",
            "http://schema.org/copyrightHolder": "EMBL - European Bioinformatics Institute",
            "http://schema.org/license": "https://www.apache.org/licenses/LICENSE-2.0"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "TransDecoder.LongOrfs"
            ],
            "inputs": [
                {
                    "format": "http://edamontology.org/format_3475",
                    "id": "#TransDecoder.LongOrfs-v5.cwl/geneToTranscriptMap",
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--gene_trans_map"
                    },
                    "label": "gene-to-transcript mapping",
                    "doc": "gene-to-transcript identifier mapping file (tab-delimited, gene_id<tab>trans_id<return>)"
                },
                {
                    "id": "#TransDecoder.LongOrfs-v5.cwl/geneticCode",
                    "type": [
                        "null",
                        "#TransDecoder-v5-genetic_codes.yaml/genetic_codes"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "-G"
                    },
                    "label": "genetic code",
                    "doc": "genetic code (default: universal; see PerlDoc; options: Euplotes, Tetrahymena, Candida, Acetabularia)"
                },
                {
                    "id": "#TransDecoder.LongOrfs-v5.cwl/minimumProteinLength",
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "-m"
                    },
                    "label": "minimum protein length",
                    "doc": "minimum protein length (default: 100)"
                },
                {
                    "id": "#TransDecoder.LongOrfs-v5.cwl/strandSpecific",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "-S"
                    },
                    "label": "strand-specific",
                    "doc": "strand-specific (only analyzes top strand)"
                },
                {
                    "format": "http://edamontology.org/format_1929",
                    "id": "#TransDecoder.LongOrfs-v5.cwl/transcriptsFile",
                    "type": "File",
                    "inputBinding": {
                        "position": 0,
                        "prefix": "-t"
                    },
                    "label": "transcripts.fasta",
                    "doc": "FASTA formatted sequence file containing your transcripts."
                }
            ],
            "outputs": [
                {
                    "id": "#TransDecoder.LongOrfs-v5.cwl/workingDir",
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "$(inputs.transcriptsFile.basename).transdecoder_dir"
                    }
                }
            ],
            "doc": "TransDecoder identifies candidate coding regions within transcript sequences, such as those generated by de novo RNA-Seq transcript assembly using Trinity, or constructed based on RNA-Seq alignments to the genome using Tophat and Cufflinks.\nTransDecoder identifies likely coding sequences based on the following criteria:\n      + a minimum length open reading frame (ORF) is found in a transcript sequence\n      + a log-likelihood score similar to what is computed by the GeneID software is > 0.\n      + the above coding score is greatest when the ORF is scored in the 1st reading frame\n      as compared to scores in the other 2 forward reading frames.\n      + if a candidate ORF is found fully encapsulated by the coordinates of another candidate ORF,\n      the longer one is reported. However, a single transcript can report multiple ORFs\n      (allowing for operons, chimeras, etc).\n      + a PSSM is built/trained/used to refine the start codon prediction.\n      + optional the putative peptide has a match to a Pfam domain above the noise cutoff score.\n\nPlease visit https://github.com/TransDecoder/TransDecoder/wiki for full documentation.\n\nReleases can be downloaded from https://github.com/TransDecoder/TransDecoder/releases",
            "label": "TransDecoder.LongOrfs: Perl script, which extracts the long open reading frames",
            "requirements": [
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "type": "enum",
                            "name": "#TransDecoder-v5-genetic_codes.yaml/genetic_codes",
                            "symbols": [
                                "#TransDecoder-v5-genetic_codes.yaml/genetic_codes/universal",
                                "#TransDecoder-v5-genetic_codes.yaml/genetic_codes/Euplotes",
                                "#TransDecoder-v5-genetic_codes.yaml/genetic_codes/Tetrahymena",
                                "#TransDecoder-v5-genetic_codes.yaml/genetic_codes/Candida",
                                "#TransDecoder-v5-genetic_codes.yaml/genetic_codes/Acetabularia",
                                "#TransDecoder-v5-genetic_codes.yaml/genetic_codes/Mitochondrial-Canonical",
                                "#TransDecoder-v5-genetic_codes.yaml/genetic_codes/Mitochondrial-Vertebrates",
                                "#TransDecoder-v5-genetic_codes.yaml/genetic_codes/Mitochondrial-Arthropods",
                                "#TransDecoder-v5-genetic_codes.yaml/genetic_codes/Mitochondrial-Echinoderms",
                                "#TransDecoder-v5-genetic_codes.yaml/genetic_codes/Mitochondrial-Molluscs",
                                "#TransDecoder-v5-genetic_codes.yaml/genetic_codes/Mitochondrial-Ascidians",
                                "#TransDecoder-v5-genetic_codes.yaml/genetic_codes/Mitochondrial-Nematodes",
                                "#TransDecoder-v5-genetic_codes.yaml/genetic_codes/Mitochondrial-Platyhelminths",
                                "#TransDecoder-v5-genetic_codes.yaml/genetic_codes/Mitochondrial-Yeasts",
                                "#TransDecoder-v5-genetic_codes.yaml/genetic_codes/Mitochondrial-Euascomycetes",
                                "#TransDecoder-v5-genetic_codes.yaml/genetic_codes/Mitochondrial-Protozoans"
                            ]
                        }
                    ]
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 1024
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "greatfireball/ime_transdecoder:5.0.2"
                },
                {
                    "class": "http://galaxyproject.org/cwl#interface",
                    "http://galaxyproject.org/cwl#inputs": [
                        {
                            "http://galaxyproject.org/cwl#name": "geneToTranscriptMap",
                            "http://galaxyproject.org/cwl#type": "data",
                            "http://galaxyproject.org/cwl#format": "txt",
                            "http://galaxyproject.org/cwl#optional": true
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "geneticCode",
                            "http://galaxyproject.org/cwl#type": "text",
                            "http://galaxyproject.org/cwl#optional": true
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "minimumProteinLength",
                            "http://galaxyproject.org/cwl#type": "integer",
                            "http://galaxyproject.org/cwl#optional": true
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "strandSpecific",
                            "http://galaxyproject.org/cwl#type": "boolean",
                            "http://galaxyproject.org/cwl#optional": true
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "transcriptsFile",
                            "http://galaxyproject.org/cwl#type": "data",
                            "http://galaxyproject.org/cwl#format": "txt"
                        }
                    ]
                }
            ],
            "id": "#TransDecoder.LongOrfs-v5.cwl",
            "http://schema.org/author": "Maxim Scheremetjew",
            "http://schema.org/copyrightHolder": "EMBL - European Bioinformatics Institute, 2018",
            "http://schema.org/license": "https://www.apache.org/licenses/LICENSE-2.0"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "TransDecoder.Predict"
            ],
            "inputs": [
                {
                    "id": "#TransDecoder.Predict-v5.cwl/geneticCode",
                    "type": [
                        "null",
                        "#TransDecoder-v5-genetic_codes.yaml/genetic_codes"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "-G"
                    },
                    "label": "genetic code",
                    "doc": "genetic code (default: universal; see PerlDoc; options: Euplotes, Tetrahymena, Candida, Acetabularia)"
                },
                {
                    "id": "#TransDecoder.Predict-v5.cwl/longOpenReadingFrames",
                    "type": "Directory"
                },
                {
                    "id": "#TransDecoder.Predict-v5.cwl/noRefineStarts",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--no_refine_starts"
                    },
                    "label": "No refine starts",
                    "doc": "Start refinement identifies potential start codons for 5' partial ORFs using a PWM, process on by default."
                },
                {
                    "id": "#TransDecoder.Predict-v5.cwl/retainBlastpHits",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--retain_blastp_hits"
                    },
                    "label": "Retain Blastp hits",
                    "doc": "blastp output in '-outfmt 6' format.\nAny ORF with a blast match will be retained in the final output.\n"
                },
                {
                    "id": "#TransDecoder.Predict-v5.cwl/retainLongOrfsLength",
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--retain_long_orfs_length"
                    },
                    "label": "Retain long ORFs length",
                    "doc": "Under 'strict' mode, retain all ORFs found that are equal or longer than these many nucleotides\neven if no other evidence marks it as coding (default: 1000000) so essentially turned off by default.\n"
                },
                {
                    "id": "#TransDecoder.Predict-v5.cwl/retainLongOrfsMode",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--retain_long_orfs_mode"
                    },
                    "label": "Retain long ORFs mode",
                    "doc": "'dynamic' (default) or 'strict'. In dynamic mode, sets range according to 1%FDR in random sequence of same GC content."
                },
                {
                    "id": "#TransDecoder.Predict-v5.cwl/retainPfamHits",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--retain_pfam_hits"
                    },
                    "label": "Retain Pfam hits",
                    "doc": "Domain table output file from running hmmscan to search Pfam (see transdecoder.github.io for info).\nAny ORF with a pfam domain hit will be retained in the final output.\n"
                },
                {
                    "id": "#TransDecoder.Predict-v5.cwl/singleBestOnly",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--single_best_only"
                    },
                    "label": "Single best only",
                    "doc": "Retain only the single best ORF per transcript (prioritized by homology then ORF length)"
                },
                {
                    "id": "#TransDecoder.Predict-v5.cwl/train",
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "-T"
                    },
                    "label": "minimum protein length",
                    "doc": "If no --train, top longest ORFs to train Markov Model (hexamer stats) (default: 500)\nNote, 10x this value are first selected for removing redundancies,\nand then this -T value of longest ORFs are selected from the non-redundant set.\n"
                },
                {
                    "format": "http://edamontology.org/format_1929",
                    "id": "#TransDecoder.Predict-v5.cwl/transcriptsFile",
                    "type": "File",
                    "inputBinding": {
                        "position": 0,
                        "prefix": "-t"
                    },
                    "label": "transcripts.fasta",
                    "doc": "FASTA formatted sequence file containing your transcripts."
                }
            ],
            "outputs": [
                {
                    "id": "#TransDecoder.Predict-v5.cwl/bed_output",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.transcriptsFile.basename).transdecoder.bed"
                    },
                    "format": "http://edamontology.org/format_3003"
                },
                {
                    "id": "#TransDecoder.Predict-v5.cwl/coding_regions",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.transcriptsFile.basename).transdecoder.cds"
                    },
                    "format": "http://edamontology.org/format_1929"
                },
                {
                    "id": "#TransDecoder.Predict-v5.cwl/gff3_output",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.transcriptsFile.basename).transdecoder.gff3"
                    },
                    "format": "http://edamontology.org/format_1975"
                },
                {
                    "id": "#TransDecoder.Predict-v5.cwl/peptide_sequences",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.transcriptsFile.basename).transdecoder.pep"
                    },
                    "format": "http://edamontology.org/format_1929"
                }
            ],
            "doc": "TransDecoder identifies candidate coding regions within transcript sequences, such as those generated by de novo RNA-Seq transcript assembly using Trinity, or constructed based on RNA-Seq alignments to the genome using Tophat and Cufflinks.\nTransDecoder identifies likely coding sequences based on the following criteria:\n      + a minimum length open reading frame (ORF) is found in a transcript sequence\n      + a log-likelihood score similar to what is computed by the GeneID software is > 0.\n      + the above coding score is greatest when the ORF is scored in the 1st reading frame\n      as compared to scores in the other 2 forward reading frames.\n      + if a candidate ORF is found fully encapsulated by the coordinates of another candidate ORF,\n      the longer one is reported. However, a single transcript can report multiple ORFs \n      (allowing for operons, chimeras, etc).\n      + a PSSM is built/trained/used to refine the start codon prediction.\n      + optional the putative peptide has a match to a Pfam domain above the noise cutoff score.\n      \nPlease visit https://github.com/TransDecoder/TransDecoder/wiki for full documentation.\nReleases can be downloaded from https://github.com/TransDecoder/TransDecoder/releases\n",
            "label": "TransDecoder.Predict: Perl script, which predicts the likely coding regions",
            "requirements": [
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "$import": "#TransDecoder-v5-genetic_codes.yaml/genetic_codes"
                        }
                    ]
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 1024
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        "$(inputs.transcriptsFile)",
                        {
                            "entryname": "$(inputs.transcriptsFile.basename).transdecoder_dir",
                            "entry": "$(inputs.longOpenReadingFrames)",
                            "writable": true
                        }
                    ]
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "greatfireball/ime_transdecoder:5.0.2"
                }
            ],
            "id": "#TransDecoder.Predict-v5.cwl",
            "http://schema.org/author": "Maxim Scheremetjew",
            "http://schema.org/copyrightHolder": "EMBL - European Bioinformatics Institute, 2018",
            "http://schema.org/license": "https://www.apache.org/licenses/LICENSE-2.0"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "cmsearch-deoverlap.pl"
            ],
            "inputs": [
                {
                    "id": "#cmsearch-deoverlap-v0.02.cwl/clan_information",
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--clanin"
                    },
                    "label": "clan information on the models provided",
                    "doc": "Not all models provided need to be a member of a clan"
                },
                {
                    "id": "#cmsearch-deoverlap-v0.02.cwl/cmsearch_matches",
                    "type": "File",
                    "inputBinding": {
                        "position": 1,
                        "valueFrom": "$(self.basename)"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#cmsearch-deoverlap-v0.02.cwl/deoverlapped_matches",
                    "doc": "http://eddylab.org/infernal/Userguide.pdf#page=60",
                    "label": "target hits table, format 2",
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.deoverlapped"
                    }
                }
            ],
            "doc": "https://github.com/nawrockie/cmsearch_tblout_deoverlap/blob/master/00README.txt",
            "label": "Remove lower scoring overlaps from cmsearch --tblout files.",
            "requirements": [
                {
                    "class": "EnvVarRequirement",
                    "envDef": [
                        {
                            "envValue": "C",
                            "envName": "LC_ALL"
                        }
                    ]
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 100,
                    "coresMax": 1
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        "$(inputs.cmsearch_matches)"
                    ]
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "class": "SoftwareRequirement",
                    "packages": [
                        {
                            "specs": [
                                "https://github.com/nawrockie/cmsearch_tblout_deoverlap"
                            ],
                            "version": [
                                "0.02"
                            ],
                            "package": "cmsearch_tblout_deoverlap"
                        }
                    ]
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "biocrusoe/cmsearch-deoverlap"
                },
                {
                    "class": "http://galaxyproject.org/cwl#interface",
                    "http://galaxyproject.org/cwl#inputs": [
                        {
                            "http://galaxyproject.org/cwl#name": "clan_information",
                            "http://galaxyproject.org/cwl#type": "data",
                            "http://galaxyproject.org/cwl#format": "txt",
                            "http://galaxyproject.org/cwl#optional": true
                        },
                        {
                            "http://galaxyproject.org/cwl#name": "cmsearch_matches",
                            "http://galaxyproject.org/cwl#type": "data",
                            "http://galaxyproject.org/cwl#format": "txt"
                        }
                    ]
                }
            ],
            "id": "#cmsearch-deoverlap-v0.02.cwl",
            "http://schema.org/copyrightHolder": "EMBL - European Bioinformatics Institute",
            "http://schema.org/license": "https://www.apache.org/licenses/LICENSE-2.0",
            "http://schema.org/author": "Michael Crusoe, Maxim Scheremetjew"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "cat"
            ],
            "inputs": [
                {
                    "id": "#concatenate.cwl/files",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "inputBinding": {
                        "position": 1
                    },
                    "streamable": true
                },
                {
                    "id": "#concatenate.cwl/outputFileName",
                    "type": "string"
                }
            ],
            "outputs": [
                {
                    "id": "#concatenate.cwl/result",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.outputFileName)",
                        "outputEval": "${ self[0].format = inputs.files[0].format;\n   return self; }\n"
                    }
                }
            ],
            "doc": "The cat (short for \u201cconcatenate\u201c) command is one of the most frequently used command in Linux/Unix like operating systems. cat command allows us to create single or multiple files, view contain of file, concatenate files and redirect output in terminal or files.\n",
            "label": "Redirecting Multiple Files Contain in a Single File",
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 100,
                    "coresMax": 1
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "alpine:3.7"
                }
            ],
            "stdout": "$(inputs.outputFileName)",
            "id": "#concatenate.cwl",
            "http://schema.org/copyrightHolder": "EMBL - European Bioinformatics Institute",
            "http://schema.org/license": "https://www.apache.org/licenses/LICENSE-2.0",
            "http://schema.org/author": "Michael Crusoe, Maxim Scheremetjew"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "esl-reformat"
            ],
            "inputs": [
                {
                    "id": "#esl-reformat.cwl/replace",
                    "type": [
                        "null",
                        "#esl-reformat-replace.yaml/replace"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--replace",
                        "valueFrom": "$(self.find):$(self.replace)"
                    }
                },
                {
                    "format": "http://edamontology.org/format_1929",
                    "id": "#esl-reformat.cwl/sequences",
                    "type": "File",
                    "inputBinding": {
                        "position": 3
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#esl-reformat.cwl/reformatted_sequences",
                    "type": "File",
                    "format": "http://edamontology.org/format_1929",
                    "outputBinding": {
                        "glob": "$(inputs.sequences.basename).reformatted_seqs"
                    }
                }
            ],
            "doc": "Normalizes input sequences to FASTA with fixed number of sequence characters\nper line using esl-reformat from https://github.com/EddyRivasLab/easel\n",
            "label": "Normalizes input sequences to FASTA using esl-reformat",
            "arguments": [
                {
                    "position": 2,
                    "valueFrom": "fasta"
                }
            ],
            "requirements": [
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "type": "record",
                            "name": "#esl-reformat-replace.yaml/replace",
                            "label": "sequence token replacement",
                            "fields": [
                                {
                                    "name": "#esl-reformat-replace.yaml/replace/find",
                                    "type": "string",
                                    "label": "find",
                                    "doc": "Must be equal length with \"replace\". Each character from the input file\nwill be replaced by its counterpart (at the same position) from \"replace\"\n"
                                },
                                {
                                    "name": "#esl-reformat-replace.yaml/replace/replace",
                                    "type": "string",
                                    "label": "replace",
                                    "doc": "must be equal length with \"find\""
                                }
                            ]
                        }
                    ]
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 100,
                    "coresMax": 1
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/hmmer:3.2--hfc679d8_3"
                }
            ],
            "stdout": "$(inputs.sequences.basename).reformatted_seqs",
            "id": "#esl-reformat.cwl",
            "http://schema.org/copyrightHolder": "EMBL - European Bioinformatics Institute, 2017",
            "http://schema.org/license": "https://www.apache.org/licenses/LICENSE-2.0",
            "http://schema.org/author": "Michael Crusoe, Maxim Scheremetjew"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "python3"
            ],
            "inputs": [
                {
                    "id": "#fasta_chunker.cwl/chunk_size",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 10
                },
                {
                    "id": "#fasta_chunker.cwl/seqs",
                    "type": "File",
                    "format": "http://edamontology.org/format_1929"
                }
            ],
            "outputs": [
                {
                    "id": "#fasta_chunker.cwl/chunks",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "chunks/*_*.fasta"
                    },
                    "format": "http://edamontology.org/format_1929"
                }
            ],
            "doc": "based upon code by developers from EMBL-EBI",
            "label": "split FASTA by number of records",
            "arguments": [
                {
                    "position": 0,
                    "prefix": "-c",
                    "valueFrom": "from Bio import SeqIO\nimport os\ncurrentSequences = []\nos.mkdir(\"$(runtime.outdir)/chunks\")\nfor record in SeqIO.parse(\"$(inputs.seqs.path)\", \"fasta\"):\n    currentSequences.append(record)\n    if len(currentSequences) == $(inputs.chunk_size):\n        fileName = currentSequences[0].id + \"_\" + currentSequences[-1].id + \".fasta\"\n        for char in [ \"/\", \" \", \":\" ]:\n            fileName = fileName.replace(char, \"_\")\n        SeqIO.write(currentSequences, \"$(runtime.outdir)/chunks/\"+fileName, \"fasta\")\n        currentSequences = []\n\n# write any remaining sequences\nif len(currentSequences) > 0:\n    fileName = currentSequences[0].id + \"_\" + currentSequences[-1].id + \".fasta\"\n    for char in [ \"/\", \" \", \":\" ]:\n        fileName = fileName.replace(char, \"_\")\n    SeqIO.write(currentSequences, \"$(runtime.outdir)/chunks/\"+fileName, \"fasta\")\n"
                }
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 100,
                    "coresMax": 1
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "biopython/biopython:latest"
                },
                {
                    "class": "SoftwareRequirement",
                    "packages": [
                        {
                            "specs": [
                                "https://identifiers.org/rrid/RRID:SCR_007173"
                            ],
                            "version": [
                                "1.65",
                                "1.66",
                                "1.69",
                                "1.72"
                            ],
                            "package": "biopython"
                        }
                    ]
                }
            ],
            "id": "#fasta_chunker.cwl",
            "http://schema.org/copyrightHolder": "EMBL - European Bioinformatics Institute",
            "http://schema.org/license": "https://www.apache.org/licenses/LICENSE-2.0",
            "http://schema.org/author": "Michael Crusoe, Maxim Scheremetjew"
        },
        {
            "class": "Workflow",
            "label": "Runs InterProScan on batches of sequences to retrieve functional annotations.",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "types": [
                        {
                            "$import": "#InterProScan-apps.yaml/apps"
                        },
                        {
                            "$import": "#InterProScan-protein_formats.yaml/protein_formats"
                        }
                    ],
                    "class": "SchemaDefRequirement"
                }
            ],
            "inputs": [
                {
                    "format": "http://edamontology.org/format_1929",
                    "id": "#InterProScan-v5-chunked-wf.cwl/inputFile",
                    "type": "File",
                    "label": "Input file path",
                    "doc": "Optional, path to fasta file that should be loaded on Master startup. Alternatively, in CONVERT mode, the InterProScan 5 XML file to convert."
                },
                {
                    "id": "#InterProScan-v5-chunked-wf.cwl/applications",
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "#InterProScan-apps.yaml/apps"
                        }
                    ],
                    "label": "Analysis",
                    "doc": "Optional, comma separated list of analyses. If this option is not set, ALL analyses will be run."
                },
                {
                    "id": "#InterProScan-v5-chunked-wf.cwl/outputFormat",
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "#InterProScan-protein_formats.yaml/protein_formats"
                        }
                    ],
                    "label": "output format",
                    "doc": "Optional, case-insensitive, comma separated list of output formats. Supported formats are TSV, XML, JSON, GFF3, HTML and SVG. Default for protein sequences are TSV, XML and GFF3, or for nucleotide sequences GFF3 and XML."
                },
                {
                    "id": "#InterProScan-v5-chunked-wf.cwl/databases",
                    "type": "Directory"
                },
                {
                    "id": "#InterProScan-v5-chunked-wf.cwl/chunk_size",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 10000
                },
                {
                    "id": "#InterProScan-v5-chunked-wf.cwl/disableResidueAnnotation",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "label": "Disables residue annotation",
                    "doc": "Optional, excludes sites from the XML, JSON output."
                },
                {
                    "id": "#InterProScan-v5-chunked-wf.cwl/seqtype",
                    "type": [
                        "null",
                        {
                            "type": "enum",
                            "symbols": [
                                "#InterProScan-v5-chunked-wf.cwl/seqtype/seqtype/p",
                                "#InterProScan-v5-chunked-wf.cwl/seqtype/seqtype/n"
                            ],
                            "name": "#InterProScan-v5-chunked-wf.cwl/seqtype/seqtype"
                        }
                    ],
                    "label": "Sequence type",
                    "doc": "Optional, the type of the input sequences (dna/rna (n) or protein (p)). The default sequence type is protein."
                },
                {
                    "id": "#InterProScan-v5-chunked-wf.cwl/catOutputFileName",
                    "type": "string",
                    "default": "full_i5_annotations"
                }
            ],
            "outputs": [
                {
                    "id": "#InterProScan-v5-chunked-wf.cwl/i5Annotations",
                    "type": "File",
                    "outputSource": "#InterProScan-v5-chunked-wf.cwl/combine_interproscan_results/result"
                }
            ],
            "steps": [
                {
                    "run": "#concatenate.cwl",
                    "in": [
                        {
                            "source": "#InterProScan-v5-chunked-wf.cwl/run_interproscan/i5Annotations",
                            "id": "#InterProScan-v5-chunked-wf.cwl/combine_interproscan_results/files"
                        },
                        {
                            "source": "#InterProScan-v5-chunked-wf.cwl/catOutputFileName",
                            "id": "#InterProScan-v5-chunked-wf.cwl/combine_interproscan_results/outputFileName"
                        }
                    ],
                    "out": [
                        "#InterProScan-v5-chunked-wf.cwl/combine_interproscan_results/result"
                    ],
                    "id": "#InterProScan-v5-chunked-wf.cwl/combine_interproscan_results"
                },
                {
                    "label": "Run InterProScan on chunked sequence files",
                    "run": "#InterProScan-v5.cwl",
                    "in": [
                        {
                            "source": "#InterProScan-v5-chunked-wf.cwl/applications",
                            "id": "#InterProScan-v5-chunked-wf.cwl/run_interproscan/applications"
                        },
                        {
                            "source": "#InterProScan-v5-chunked-wf.cwl/databases",
                            "id": "#InterProScan-v5-chunked-wf.cwl/run_interproscan/databases"
                        },
                        {
                            "source": "#InterProScan-v5-chunked-wf.cwl/disableResidueAnnotation",
                            "id": "#InterProScan-v5-chunked-wf.cwl/run_interproscan/disableResidueAnnotation"
                        },
                        {
                            "source": "#InterProScan-v5-chunked-wf.cwl/split_seqs/chunks",
                            "id": "#InterProScan-v5-chunked-wf.cwl/run_interproscan/inputFile"
                        },
                        {
                            "source": "#InterProScan-v5-chunked-wf.cwl/outputFormat",
                            "id": "#InterProScan-v5-chunked-wf.cwl/run_interproscan/outputFormat"
                        }
                    ],
                    "scatter": "#InterProScan-v5-chunked-wf.cwl/run_interproscan/inputFile",
                    "out": [
                        "#InterProScan-v5-chunked-wf.cwl/run_interproscan/i5Annotations"
                    ],
                    "id": "#InterProScan-v5-chunked-wf.cwl/run_interproscan"
                },
                {
                    "run": "#fasta_chunker.cwl",
                    "in": [
                        {
                            "source": "#InterProScan-v5-chunked-wf.cwl/chunk_size",
                            "id": "#InterProScan-v5-chunked-wf.cwl/split_seqs/chunk_size"
                        },
                        {
                            "source": "#InterProScan-v5-chunked-wf.cwl/inputFile",
                            "id": "#InterProScan-v5-chunked-wf.cwl/split_seqs/seqs"
                        }
                    ],
                    "out": [
                        "#InterProScan-v5-chunked-wf.cwl/split_seqs/chunks"
                    ],
                    "id": "#InterProScan-v5-chunked-wf.cwl/split_seqs"
                }
            ],
            "id": "#InterProScan-v5-chunked-wf.cwl",
            "http://schema.org/author": "Maxim Scheremetjew",
            "http://schema.org/copyrightHolder": "EMBL - European Bioinformatics Institute",
            "http://schema.org/license": "https://www.apache.org/licenses/LICENSE-2.0"
        },
        {
            "class": "Workflow",
            "label": "TransDecoder 2 step workflow, running TransDecoder.LongOrfs (step 1) followed by TransDecoder.Predict (step2)",
            "inputs": [
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#TransDecoder-v5-wf-2steps.cwl/singleBestOnly"
                },
                {
                    "format": "http://edamontology.org/format_1929",
                    "type": "File",
                    "id": "#TransDecoder-v5-wf-2steps.cwl/transcriptsFile"
                }
            ],
            "outputs": [
                {
                    "outputSource": "#TransDecoder-v5-wf-2steps.cwl/predict_coding_regions/bed_output",
                    "type": "File",
                    "id": "#TransDecoder-v5-wf-2steps.cwl/bed_output"
                },
                {
                    "outputSource": "#TransDecoder-v5-wf-2steps.cwl/predict_coding_regions/coding_regions",
                    "type": "File",
                    "id": "#TransDecoder-v5-wf-2steps.cwl/coding_regions"
                },
                {
                    "outputSource": "#TransDecoder-v5-wf-2steps.cwl/predict_coding_regions/gff3_output",
                    "type": "File",
                    "id": "#TransDecoder-v5-wf-2steps.cwl/gff3_output"
                },
                {
                    "outputSource": "#TransDecoder-v5-wf-2steps.cwl/predict_coding_regions/peptide_sequences",
                    "type": "File",
                    "id": "#TransDecoder-v5-wf-2steps.cwl/peptide_sequences"
                }
            ],
            "steps": [
                {
                    "label": "Extracts the long open reading frames",
                    "run": "#TransDecoder.LongOrfs-v5.cwl",
                    "in": [
                        {
                            "source": "#TransDecoder-v5-wf-2steps.cwl/transcriptsFile",
                            "id": "#TransDecoder-v5-wf-2steps.cwl/extract_long_orfs/transcriptsFile"
                        }
                    ],
                    "out": [
                        "#TransDecoder-v5-wf-2steps.cwl/extract_long_orfs/workingDir"
                    ],
                    "id": "#TransDecoder-v5-wf-2steps.cwl/extract_long_orfs"
                },
                {
                    "label": "Predicts the likely coding regions",
                    "run": "#TransDecoder.Predict-v5.cwl",
                    "in": [
                        {
                            "source": "#TransDecoder-v5-wf-2steps.cwl/extract_long_orfs/workingDir",
                            "id": "#TransDecoder-v5-wf-2steps.cwl/predict_coding_regions/longOpenReadingFrames"
                        },
                        {
                            "source": "#TransDecoder-v5-wf-2steps.cwl/singleBestOnly",
                            "id": "#TransDecoder-v5-wf-2steps.cwl/predict_coding_regions/singleBestOnly"
                        },
                        {
                            "source": "#TransDecoder-v5-wf-2steps.cwl/transcriptsFile",
                            "id": "#TransDecoder-v5-wf-2steps.cwl/predict_coding_regions/transcriptsFile"
                        }
                    ],
                    "out": [
                        "#TransDecoder-v5-wf-2steps.cwl/predict_coding_regions/bed_output",
                        "#TransDecoder-v5-wf-2steps.cwl/predict_coding_regions/coding_regions",
                        "#TransDecoder-v5-wf-2steps.cwl/predict_coding_regions/gff3_output",
                        "#TransDecoder-v5-wf-2steps.cwl/predict_coding_regions/peptide_sequences"
                    ],
                    "id": "#TransDecoder-v5-wf-2steps.cwl/predict_coding_regions"
                }
            ],
            "id": "#TransDecoder-v5-wf-2steps.cwl",
            "http://schema.org/copyrightHolder": "EMBL - European Bioinformatics Institute, 2018",
            "http://schema.org/license": "https://www.apache.org/licenses/LICENSE-2.0",
            "http://schema.org/author": "Maxim Scheremetjew"
        },
        {
            "class": "Workflow",
            "label": "Transcripts annotation workflow",
            "requirements": [
                {
                    "class": "SubworkflowFeatureRequirement"
                },
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "$import": "#esl-reformat-replace.yaml/replace"
                        },
                        {
                            "$import": "#BUSCO-assessment_modes.yaml/assessment_modes"
                        },
                        {
                            "$import": "#InterProScan-apps.yaml/apps"
                        },
                        {
                            "$import": "#InterProScan-protein_formats.yaml/protein_formats"
                        }
                    ]
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "id": "#main/blockSize"
                },
                {
                    "type": "Directory",
                    "id": "#main/buscoLineage"
                },
                {
                    "type": "#BUSCO-assessment_modes.yaml/assessment_modes",
                    "id": "#main/buscoMode"
                },
                {
                    "type": "string",
                    "id": "#main/buscoOutputName"
                },
                {
                    "type": "File",
                    "id": "#main/clanInfoFile"
                },
                {
                    "type": "int",
                    "id": "#main/cmsearchCores"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/covariance_models"
                },
                {
                    "type": "File",
                    "id": "#main/diamondSeqdb"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "#InterProScan-apps.yaml/apps"
                        }
                    ],
                    "id": "#main/i5Applications"
                },
                {
                    "type": "Directory",
                    "id": "#main/i5Databases"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "#InterProScan-protein_formats.yaml/protein_formats"
                        }
                    ],
                    "id": "#main/i5OutputFormat"
                },
                {
                    "type": "File",
                    "format": "http://edamontology.org/format_1929",
                    "id": "#main/phmmerSeqdb"
                },
                {
                    "type": [
                        "null",
                        "#esl-reformat-replace.yaml/replace"
                    ],
                    "id": "#main/replace"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#main/singleBestOnly"
                },
                {
                    "type": "File",
                    "format": "http://edamontology.org/format_1929",
                    "id": "#main/transcriptsFile"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/identify_coding_regions/bed_output",
                    "id": "#main/bed_output"
                },
                {
                    "type": "Directory",
                    "outputSource": "#main/run_transcriptome_assessment/blastOutput",
                    "id": "#main/busco_blast_output"
                },
                {
                    "type": "File",
                    "outputSource": "#main/run_transcriptome_assessment/fullTable",
                    "id": "#main/busco_full_table"
                },
                {
                    "type": "Directory",
                    "outputSource": "#main/run_transcriptome_assessment/hmmerOutput",
                    "id": "#main/busco_hmmer_output"
                },
                {
                    "type": "File",
                    "outputSource": "#main/run_transcriptome_assessment/missingBUSCOs",
                    "id": "#main/busco_missing_buscos"
                },
                {
                    "type": "File",
                    "outputSource": "#main/run_transcriptome_assessment/shortSummary",
                    "id": "#main/busco_short_summary"
                },
                {
                    "type": "Directory",
                    "outputSource": "#main/run_transcriptome_assessment/translatedProteins",
                    "id": "#main/busco_translated_proteins"
                },
                {
                    "type": "File",
                    "outputSource": "#main/identify_coding_regions/coding_regions",
                    "id": "#main/coding_regions"
                },
                {
                    "type": "File",
                    "outputSource": "#main/identify_nc_rna/deoverlapped_matches",
                    "id": "#main/deoverlapped_matches"
                },
                {
                    "type": "File",
                    "outputSource": "#main/calculate_diamond_matches/matches",
                    "id": "#main/diamond_matches"
                },
                {
                    "type": "File",
                    "outputSource": "#main/identify_coding_regions/gff3_output",
                    "id": "#main/gff3_output"
                },
                {
                    "type": "File",
                    "outputSource": "#main/functional_analysis/i5Annotations",
                    "id": "#main/i5Annotations"
                },
                {
                    "type": "File",
                    "outputSource": "#main/identify_coding_regions/peptide_sequences",
                    "id": "#main/peptide_sequences"
                },
                {
                    "type": "File",
                    "outputSource": "#main/calculate_phmmer_matches/matches",
                    "id": "#main/phmmer_matches"
                },
                {
                    "type": "File",
                    "outputSource": "#main/remove_asterisks_and_reformat/reformatted_sequences",
                    "id": "#main/reformatted_sequences"
                }
            ],
            "steps": [
                {
                    "label": "Calculates Diamond matches",
                    "run": "#Diamon.blastx-v0.9.21.cwl",
                    "in": [
                        {
                            "source": "#main/blockSize",
                            "id": "#main/calculate_diamond_matches/blockSize"
                        },
                        {
                            "source": "#main/diamondSeqdb",
                            "id": "#main/calculate_diamond_matches/databaseFile"
                        },
                        {
                            "source": "#main/transcriptsFile",
                            "id": "#main/calculate_diamond_matches/queryInputFile"
                        }
                    ],
                    "out": [
                        "#main/calculate_diamond_matches/matches"
                    ],
                    "id": "#main/calculate_diamond_matches"
                },
                {
                    "label": "Calculates phmmer matches",
                    "run": "#phmmer-v3.2.cwl",
                    "in": [
                        {
                            "source": "#main/identify_coding_regions/peptide_sequences",
                            "id": "#main/calculate_phmmer_matches/seqFile"
                        },
                        {
                            "source": "#main/phmmerSeqdb",
                            "id": "#main/calculate_phmmer_matches/seqdb"
                        }
                    ],
                    "out": [
                        "#main/calculate_phmmer_matches/matches",
                        "#main/calculate_phmmer_matches/programOutput"
                    ],
                    "id": "#main/calculate_phmmer_matches"
                },
                {
                    "doc": "Matches are generated against predicted CDS, using a sub set of databases\nfrom InterPro.\n",
                    "run": "#InterProScan-v5-chunked-wf.cwl",
                    "in": [
                        {
                            "source": "#main/i5Applications",
                            "id": "#main/functional_analysis/applications"
                        },
                        {
                            "source": "#main/i5Databases",
                            "id": "#main/functional_analysis/databases"
                        },
                        {
                            "source": "#main/remove_asterisks_and_reformat/reformatted_sequences",
                            "id": "#main/functional_analysis/inputFile"
                        },
                        {
                            "source": "#main/i5OutputFormat",
                            "id": "#main/functional_analysis/outputFormat"
                        }
                    ],
                    "out": [
                        "#main/functional_analysis/i5Annotations"
                    ],
                    "id": "#main/functional_analysis"
                },
                {
                    "label": "Identifies candidate coding regions within transcript sequences",
                    "run": "#TransDecoder-v5-wf-2steps.cwl",
                    "in": [
                        {
                            "source": "#main/singleBestOnly",
                            "id": "#main/identify_coding_regions/singleBestOnly"
                        },
                        {
                            "source": "#main/transcriptsFile",
                            "id": "#main/identify_coding_regions/transcriptsFile"
                        }
                    ],
                    "out": [
                        "#main/identify_coding_regions/peptide_sequences",
                        "#main/identify_coding_regions/coding_regions",
                        "#main/identify_coding_regions/gff3_output",
                        "#main/identify_coding_regions/bed_output"
                    ],
                    "id": "#main/identify_coding_regions"
                },
                {
                    "label": "Identifies non-coding RNAs using Rfams covariance models",
                    "run": "#cmsearch-multimodel-wf.cwl",
                    "in": [
                        {
                            "source": "#main/clanInfoFile",
                            "id": "#main/identify_nc_rna/clan_info"
                        },
                        {
                            "source": "#main/cmsearchCores",
                            "id": "#main/identify_nc_rna/cores"
                        },
                        {
                            "source": "#main/covariance_models",
                            "id": "#main/identify_nc_rna/covariance_models"
                        },
                        {
                            "source": "#main/transcriptsFile",
                            "id": "#main/identify_nc_rna/query_sequences"
                        }
                    ],
                    "out": [
                        "#main/identify_nc_rna/deoverlapped_matches"
                    ],
                    "id": "#main/identify_nc_rna"
                },
                {
                    "label": "Removes asterisks characters from given peptide sequences",
                    "run": "#esl-reformat.cwl",
                    "in": [
                        {
                            "source": "#main/replace",
                            "id": "#main/remove_asterisks_and_reformat/replace"
                        },
                        {
                            "source": "#main/identify_coding_regions/peptide_sequences",
                            "id": "#main/remove_asterisks_and_reformat/sequences"
                        }
                    ],
                    "out": [
                        "#main/remove_asterisks_and_reformat/reformatted_sequences"
                    ],
                    "id": "#main/remove_asterisks_and_reformat"
                },
                {
                    "label": "Performs transcriptome assessment using BUSCO",
                    "run": "#BUSCO-v3.cwl",
                    "in": [
                        {
                            "source": "#main/buscoLineage",
                            "id": "#main/run_transcriptome_assessment/lineage"
                        },
                        {
                            "source": "#main/buscoMode",
                            "id": "#main/run_transcriptome_assessment/mode"
                        },
                        {
                            "source": "#main/buscoOutputName",
                            "id": "#main/run_transcriptome_assessment/outputName"
                        },
                        {
                            "source": "#main/transcriptsFile",
                            "id": "#main/run_transcriptome_assessment/sequenceFile"
                        }
                    ],
                    "out": [
                        "#main/run_transcriptome_assessment/shortSummary",
                        "#main/run_transcriptome_assessment/fullTable",
                        "#main/run_transcriptome_assessment/missingBUSCOs",
                        "#main/run_transcriptome_assessment/hmmerOutput",
                        "#main/run_transcriptome_assessment/translatedProteins",
                        "#main/run_transcriptome_assessment/blastOutput"
                    ],
                    "id": "#main/run_transcriptome_assessment"
                }
            ],
            "id": "#main",
            "http://schema.org/license": "https://www.apache.org/licenses/LICENSE-2.0",
            "http://schema.org/copyrightHolder": "EMBL - European Bioinformatics Institute, 2018"
        },
        {
            "class": "Workflow",
            "label": "Identifies non-coding RNAs using Rfams covariance models",
            "inputs": [
                {
                    "type": "string",
                    "default": "full_cmsearch_output",
                    "id": "#cmsearch-multimodel-wf.cwl/catOutputFileName"
                },
                {
                    "type": "File",
                    "id": "#cmsearch-multimodel-wf.cwl/clan_info"
                },
                {
                    "type": "int",
                    "id": "#cmsearch-multimodel-wf.cwl/cores"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#cmsearch-multimodel-wf.cwl/covariance_models"
                },
                {
                    "type": "File",
                    "id": "#cmsearch-multimodel-wf.cwl/query_sequences"
                }
            ],
            "outputs": [
                {
                    "outputSource": "#cmsearch-multimodel-wf.cwl/remove_overlaps/deoverlapped_matches",
                    "type": "File",
                    "id": "#cmsearch-multimodel-wf.cwl/deoverlapped_matches"
                }
            ],
            "steps": [
                {
                    "label": "Search sequence(s) against a covariance model database",
                    "run": "#infernal-cmsearch-v1.1.2.cwl",
                    "scatter": "#cmsearch-multimodel-wf.cwl/cmsearch/covariance_model_database",
                    "in": [
                        {
                            "source": "#cmsearch-multimodel-wf.cwl/covariance_models",
                            "id": "#cmsearch-multimodel-wf.cwl/cmsearch/covariance_model_database"
                        },
                        {
                            "source": "#cmsearch-multimodel-wf.cwl/cores",
                            "id": "#cmsearch-multimodel-wf.cwl/cmsearch/cpu"
                        },
                        {
                            "default": true,
                            "id": "#cmsearch-multimodel-wf.cwl/cmsearch/omit_alignment_section"
                        },
                        {
                            "default": true,
                            "id": "#cmsearch-multimodel-wf.cwl/cmsearch/only_hmm"
                        },
                        {
                            "source": "#cmsearch-multimodel-wf.cwl/query_sequences",
                            "id": "#cmsearch-multimodel-wf.cwl/cmsearch/query_sequences"
                        },
                        {
                            "default": 1000,
                            "id": "#cmsearch-multimodel-wf.cwl/cmsearch/search_space_size"
                        }
                    ],
                    "out": [
                        "#cmsearch-multimodel-wf.cwl/cmsearch/matches",
                        "#cmsearch-multimodel-wf.cwl/cmsearch/programOutput"
                    ],
                    "id": "#cmsearch-multimodel-wf.cwl/cmsearch"
                },
                {
                    "run": "#concatenate.cwl",
                    "in": [
                        {
                            "source": "#cmsearch-multimodel-wf.cwl/cmsearch/matches",
                            "id": "#cmsearch-multimodel-wf.cwl/concatenate_matches/files"
                        },
                        {
                            "source": "#cmsearch-multimodel-wf.cwl/catOutputFileName",
                            "id": "#cmsearch-multimodel-wf.cwl/concatenate_matches/outputFileName"
                        }
                    ],
                    "out": [
                        "#cmsearch-multimodel-wf.cwl/concatenate_matches/result"
                    ],
                    "id": "#cmsearch-multimodel-wf.cwl/concatenate_matches"
                },
                {
                    "label": "Remove lower scoring overlaps from cmsearch --tblout files.",
                    "run": "#cmsearch-deoverlap-v0.02.cwl",
                    "in": [
                        {
                            "source": "#cmsearch-multimodel-wf.cwl/clan_info",
                            "id": "#cmsearch-multimodel-wf.cwl/remove_overlaps/clan_information"
                        },
                        {
                            "source": "#cmsearch-multimodel-wf.cwl/concatenate_matches/result",
                            "id": "#cmsearch-multimodel-wf.cwl/remove_overlaps/cmsearch_matches"
                        }
                    ],
                    "out": [
                        "#cmsearch-multimodel-wf.cwl/remove_overlaps/deoverlapped_matches"
                    ],
                    "id": "#cmsearch-multimodel-wf.cwl/remove_overlaps"
                }
            ],
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                }
            ],
            "id": "#cmsearch-multimodel-wf.cwl",
            "http://schema.org/copyrightHolder": "EMBL - European Bioinformatics Institute",
            "http://schema.org/license": "https://www.apache.org/licenses/LICENSE-2.0",
            "http://schema.org/author": "Maxim Scheremetjew"
        }
    ],
    "cwlVersion": "v1.0",
    "$schemas": [
        "http://edamontology.org/EDAM_1.20.owl",
        "https://schema.org/docs/schema_org_rdfa.html",
        "http://edamontology.org/EDAM_1.16.owl"
    ],
    "$namespaces": {
        "edam": "http://edamontology.org/",
        "s": "http://schema.org/"
    }
}
